#ifndef _fencer_render_h
#define _fencer_render_h

#include <SDL2/SDL_render.h>
#include <SDL2/SDL_rect.h>
#include "vmath.h"

struct Program;
struct ProgramSettings;

struct RenderContext {
    // renderer created from window in Program passed to render_init
    SDL_Renderer* renderer;

    // render target
    SDL_Texture* render_target;
    // area of window to render render_target to
    SDL_Rect render_area;

    // size of render_target
    IVector render_resolution;

    // current world location of camera
    IVector camera_offset;
};

extern struct RenderContext* render_init(const struct Program* program, const struct ProgramSettings* settings);
extern void render_destroy(struct RenderContext* self);
extern void render_present(struct RenderContext* self);

extern void render_calculate_render_area(struct RenderContext* self);
extern IVector render_get_window_size(struct RenderContext* self);
extern void render_handle_resize(struct RenderContext* self);


#endif // !_fencer_render_h
